const
  k = 2;
end_const;

var
  Ro = real, 0;
  Ti = real, 0;
  Td = real, 0;
  Tv = real, 0;
  ziadana = real, 0;
  merana = real, 0;
  vystup = real, 0;
  regulacia = boolean, false;
  e_max = real, 0;
  K = real, 0;
  T1 = real, 0;
  reg_c = boolean, false;
  reg_cd = boolean, false;
  reg_t = boolean, false;
  reg_td = boolean, false;
  e = array[ 1..3 ] of real, 0;
  w = array[ 1..3 ] of real, 0;
  y = array[ 1..3 ] of real, 0;
  u = array[ 1..3 ] of real, 0;
end_var;

driver
  model = MODEL.DLL, MODEL.DMF, MODEL.PAR;
end_driver;

channel
  MERANA = real, 5, model, input;
  VYSTUP = real, 1, model, output, 0;
end_channel;

timer

  sequencer seq_1;
    timer = 0.5;
  end_sequencer;

end_timer;

instrument

  window panel panel;
    owner = background;
    position = 30, 50, 740, 350;
    win_disable = zoom, maximize, lower, winlist;
    win_title = 'Spojit regultor';
  end_panel;

  multi_switch prepinac;
    owner = panel;
    position = 34, 94, 122, 78;
    mode = radio_button;
    item
      text = 'Classical';
      output = reg_c;
    end_item;
    item
      text = 'ClassicalDelay';
      output = reg_cd;
    end_item;
    item
      text = 'Takahashi';
      output = reg_t;
      selected;
    end_item;
    item
      text = 'TakahashiDelay';
      output = reg_td;
    end_item;
  end_multi_switch;

  label text;
    owner = panel;
    position = 32, 72;
    font = SYSTEM, 10, bold;
    text = ' Typ regultora ';
  end_label;

  switch spinac;
    owner = panel;
    position = 24, 18, 218, 38;
    tab_select = 1;
    output = regulacia;
    mode = text_button;
    true_text = 'Regulciu vypn';
    false_text = 'Regulciu zapn';
  end_switch;

  chart zapisovac;
    timer = seq_1, 3;
    owner = panel;
    position = 276, 18, 440, 250;
    mode = flow_graph;
    history = 440;
    item
      expression = MERANA;
      color = lyellow;
    end_item;
    item
      expression = ziadana;
      color = lgreen;
    end_item;
    item
      expression = VYSTUP;
      color = white;
    end_item;
    colors
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_chart;

  meter mer;
    timer = seq_1, 1;
    owner = panel;
    position = 426, 300, 142, 22;
    expression = MERANA;
    mode = text_display;
    range_to = 1000;
    font = SYSTEM, 10, bold;
    colors
      ink = lyellow;
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_meter;

  meter vyst;
    timer = seq_1, 2;
    owner = panel;
    position = 574, 300, 142, 22;
    expression = VYSTUP;
    mode = text_display;
    range_to = 1000;
    font = SYSTEM, 10, bold;
    colors
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_meter;

  label text;
    owner = panel;
    position = 426, 282;
    font = SYSTEM, 10, normal;
    text = 'regulovan veliina';
  end_label;

  label text;
    owner = panel;
    position = 276, 282;
    font = SYSTEM, 10, normal;
    text = 'iadan hodnota';
  end_label;

  label text;
    owner = panel;
    position = 574, 282;
    font = SYSTEM, 10, normal;
    text = 'akn zsah';
  end_label;

  control par;
    owner = panel;
    position = 162, 216, 68, 18;
    tab_select = 2;
    output = Ro;
    mode = count_box;
    init_value = 1;
    real_step = 0.1;
    dec_places = 1;
  end_control;

  label text;
    owner = panel;
    position = 36, 219;
    font = SYSTEM, 10, normal;
    text = 'Ro - zosilnenie';
  end_label;

  label text;
    owner = panel;
    position = 36, 239;
    font = SYSTEM, 10, normal;
    text = 'Ti - integran';
  end_label;

  control par;
    owner = panel;
    position = 162, 236, 68, 18;
    tab_select = 3;
    output = Ti;
    mode = count_box;
    range_to = 1000;
    init_value = 10;
    real_step = 0.1;
    dec_places = 1;
  end_control;

  label text;
    owner = panel;
    position = 36, 259;
    font = SYSTEM, 10, normal;
    text = 'Td - derivan';
  end_label;

  control par;
    owner = panel;
    position = 162, 256, 68, 18;
    tab_select = 4;
    output = Td;
    mode = count_box;
    range_to = 1000;
    real_step = 0.1;
    dec_places = 1;
  end_control;

  label text;
    owner = panel;
    position = 36, 279;
    font = SYSTEM, 10, normal;
    text = 'Tv - per. vzrorkovania';
  end_label;

  control par;
    owner = panel;
    position = 162, 276, 68, 18;
    tab_select = 5;
    output = Tv;
    mode = count_box;
    init_value = 0.5;
    real_step = 0.1;
    dec_places = 1;
  end_control;

  label text;
    owner = panel;
    position = 32, 194;
    font = SYSTEM, 10, bold;
    text = ' Parametre regultora ';
  end_label;

  label text;
    owner = panel;
    position = 36, 299;
    font = SYSTEM, 10, normal;
    text = 'K';
  end_label;

  control par;
    owner = panel;
    position = 162, 296, 68, 18;
    tab_select = 6;
    output = K;
    mode = count_box;
    range_from = 0.1;
    range_to = 0.3;
    init_value = 0.1;
    real_step = 0.01;
    dec_places = 2;
  end_control;

  control ziad;
    owner = panel;
    position = 276, 300, 143, 22;
    tab_select = 7;
    output = ziadana;
    mode = count_box;
    init_value = 50;
    colors
      text_ink = lgreen;
      text_paper = dgray;
    end_colors;
  end_control;

  string_display ramcek;
    owner = panel;
    position = 25, 79, 216, 96;
    expression = ' ';
    colors
      top_shadow = white;
      bottom_shadow = black;
    end_colors;
  end_string_display;

  string_display ramcek;
    owner = panel;
    position = 24, 78, 218, 98;
    expression = ' ';
  end_string_display;

  string_display ramcek;
    owner = panel;
    position = 25, 201, 216, 120;
    expression = ' ';
    colors
      top_shadow = white;
      bottom_shadow = black;
    end_colors;
  end_string_display;

  string_display ramcek;
    owner = panel;
    position = 24, 200, 218, 122;
    expression = ' ';
  end_string_display;

  program regulator;
    timer = seq_1, 4;
    begin
      if regulacia then
      (* vstupn hodnoty *)
        w[(k+1)]=ziadana;
        y[(k+1)]=MERANA;
      (* reg. odchlky *)
        e[(k+1)]=w[(k+1)]-y[(k+1)];
        e[k]=w[k]-y[k];
        e[(k-1)]=w[(k-1)]-y[(k-1)];
      (* vztahy pre vypocet akcneho zasahu *)
        (* Classical *)
        if reg_c then
          u[(k+1)]=u[k]+Ro*(e[(k+1)]-e[k]+(Tv/Ti)*e[(k+1)]+(Td/Tv)*(e[(k+1)]-2*e[k]+e[(k-1)]));
        end;
        (* ClassicalDelay *)
        if reg_cd then
          T1=K*Td;
          u[(k+1)]=u[k]+(T1/(T1+Tv))*(u[k]-u[(k-1)])+(Tv/(T1+Tv))*Ro*((e[(k+1)]-e[k])*((Ti+T1)/Ti)+((Tv/Ti)*e[(k+1)])+(((T1+Td)/Tv)*(e[(k+1)]-2*e[k]-e[(k-1)])));
        end;
        (* Takahashi *)
        if reg_t then
          u[(k+1)]=u[k]+Ro*(y[k]-y[(k+1)]+(Tv/Ti)*e[(k+1)]+(Td/Tv)*(2*y[k]-y[(k+1)]-y[(k-1)]));
        end;
        (* TakahashiDelay *)
        if reg_td then
          T1=K*Td;
          u[(k+1)]=u[k]+(T1/(T1+Tv))*(u[k]-u[(k-1)])+(Tv/(T1+Tv))*Ro*((y[(k+1)]-y[k])*((Ti+T1)/Ti)+((Tv/Ti)*e[(k+1)])+(((T1+Td)/Tv)*(2*y[k]-y[(k+1)]-y[(k-1)])));
        end;
      (* akn zsah *)
        VYSTUP=u[(k+1)];
      (* posun spracovavanych hodnot *)
        u[k]=u[(k+1)];
        w[(k-1)]=w[k];
        y[(k-1)]=y[k];
        w[k]=w[(k+1)];
        y[k]=y[(k+1)];
      end;
    end;
  end_program;

  program startup;
    begin
      panel.Select();
    end;
  end_program;

end_instrument;

